"""init

迁移 ID: f67eb52d6a0f
父迁移: 
创建时间: 2024-04-30 09:16:57.996987

"""
from __future__ import annotations

from collections.abc import Sequence

from alembic import op
import sqlalchemy as sa


revision: str = 'f67eb52d6a0f'
down_revision: str | Sequence[str] | None = None
branch_labels: str | Sequence[str] | None = ('nonebot_plugin_ai_timetable',)
depends_on: str | Sequence[str] | None = None


def upgrade(name: str = "") -> None:
    if name:
        return
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('nonebot_plugin_ai_timetable_user',
    sa.Column('user_id', sa.TEXT(), nullable=False),
    sa.Column('response_url', sa.TEXT(), nullable=False),
    sa.Column('base_url', sa.TEXT(), nullable=False),
    sa.Column('current', sa.Integer(), nullable=False),
    sa.Column('name', sa.TEXT(), nullable=False),
    sa.Column('afternoonNum', sa.Integer(), nullable=False),
    sa.Column('createTime', sa.Integer(), nullable=False),
    sa.Column('isWeekend', sa.Integer(), nullable=False),
    sa.Column('morningNum', sa.Integer(), nullable=False),
    sa.Column('nightNum', sa.Integer(), nullable=False),
    sa.Column('presentWeek', sa.Integer(), nullable=False),
    sa.Column('sectionTimes', sa.TEXT(), nullable=False),
    sa.Column('speak', sa.Integer(), nullable=False),
    sa.Column('startSemester', sa.TEXT(), nullable=False),
    sa.Column('totalWeek', sa.Integer(), nullable=False),
    sa.Column('weekStart', sa.Integer(), nullable=False),
    sa.PrimaryKeyConstraint('user_id', name=op.f('pk_nonebot_plugin_ai_timetable_user')),
    info={'bind_key': 'nonebot_plugin_ai_timetable'}
    )
    op.create_table('nonebot_plugin_ai_timetable_course',
    sa.Column('course_id', sa.Integer(), nullable=False),
    sa.Column('day', sa.Integer(), nullable=False),
    sa.Column('name', sa.TEXT(), nullable=False),
    sa.Column('position', sa.TEXT(), nullable=False),
    sa.Column('sections', sa.TEXT(), nullable=False),
    sa.Column('teacher', sa.TEXT(), nullable=False),
    sa.Column('weeks', sa.TEXT(), nullable=False),
    sa.Column('user_id', sa.TEXT(), nullable=False),
    sa.ForeignKeyConstraint(['user_id'], ['nonebot_plugin_ai_timetable_user.user_id'], name=op.f('fk_nonebot_plugin_ai_timetable_course_user_id_nonebot_plugin_ai_timetable_user')),
    sa.PrimaryKeyConstraint('course_id', name=op.f('pk_nonebot_plugin_ai_timetable_course')),
    info={'bind_key': 'nonebot_plugin_ai_timetable'}
    )
    # ### end Alembic commands ###


def downgrade(name: str = "") -> None:
    if name:
        return
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_table('nonebot_plugin_ai_timetable_course')
    op.drop_table('nonebot_plugin_ai_timetable_user')
    # ### end Alembic commands ###
